/*
 * This file is part of ArmarX.
 *
 * Copyright (C) 2012-2016, High Performance Humanoid Technologies (H2T),
 * Karlsruhe Institute of Technology (KIT), all rights reserved.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Mirko Waechter (waechter at kit dot edu)
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#include "KinematicUnitInterfaceStdOverloads.h"

using namespace armarx;

std::string to_string(const ErrorStatus& status)
{
    switch (status)
    {
        case armarx::eOk:
            return "Ok";

        case armarx::eWarning:
            return "Warning";

        case armarx::eError:
            return "Error";

        default:
            return "?";
    }
}


std::string to_string(const OperationStatus& status)
{
    switch (status)
    {
        case armarx::eOffline:
            return "Offline";

        case armarx::eOnline:
            return "Online";

        case armarx::eInitialized:
            return "Initialized";

        default:
            return "?";
    }
}
