/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    RobotAPI::NJointControllerInterface
 * @author     Mirko Waechter ( mirko dot waechter at kit dot edu )
 * @date       2017
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <RobotAPI/interface/units/RobotUnit/NJointController.ice>

module armarx
{
    class NJointTaskSpaceImpedanceControlConfig extends NJointControllerConfig
    {
        Ice::FloatSeq desiredPose;
        Ice::FloatSeq desiredTwist;

        Ice::FloatSeq Kpos;
        Ice::FloatSeq Kori;
        Ice::FloatSeq Dpos;
        Ice::FloatSeq Dori;

        string nodeSetName;
        float torqueLimit;

        float Knull;
        float Dnull;

        Ice::FloatSeq desiredJointPositions;
    };

    interface NJointTaskSpaceImpedanceControlInterface extends NJointControllerInterface
    {
        void setTarget(Ice::FloatSeq target);
        void setImpedanceParameters(string paraName, Ice::FloatSeq vals);
    };

};
