#pragma once

#include <memory>

class TorqueEstimationNetwork
{
public:
    TorqueEstimationNetwork() {}
    ~TorqueEstimationNetwork() {}

    float feedforward(float vel_input, float pwm_input, float pwmXvel);

private:
    // Neural Network definition
    float layer_in[5];
    float fcl1[16];
    float fcl2[16];
    float fcl3[1];

    template <unsigned int layer_in_dim, unsigned int layer_out_dim>
    void fully_connected_layer_sigmoid_forward(float (&layer_in) [layer_in_dim],
            float (&layer_out) [layer_out_dim],
            const float (&layer_weights) [layer_in_dim][layer_out_dim],
            const float (&layer_bias) [layer_out_dim]);

    template <unsigned int layer_in_dim, unsigned int layer_out_dim>
    void fully_connected_layer_forward(float (&layer_in) [layer_in_dim],
                                       float (&layer_out) [layer_out_dim],
                                       const float (&layer_weights) [layer_in_dim][layer_out_dim],
                                       const float (&layer_bias) [layer_out_dim]);
};
using TorqueEstimationNetworkPtr = std::shared_ptr<TorqueEstimationNetwork>;
