
#pragma once

#include <RobotAPI/components/units/RobotUnit/NJointControllers/NJointController.h>
#include <VirtualRobot/Robot.h>
#include <RobotAPI/components/units/RobotUnit/RobotUnit.h>
#include <RobotAPI/components/units/RobotUnit/ControlTargets/ControlTarget1DoFActuator.h>
#include <RobotAPI/interface/units/RobotUnit/NJointGripperController.h>


namespace armarx
{


    TYPEDEF_PTRS_HANDLE(NJointGripperZeroTorqueController);
    TYPEDEF_PTRS_HANDLE(NJointGripperZeroTorqueControllerControlData);


    class NJointGripperZeroTorqueControllerControlData
    {
    };

    /**
     * @brief The NJointGripperZeroTorqueController class
     * @ingroup Library-RobotUnit-NJointControllers
     */
    class NJointGripperZeroTorqueController :
        public NJointControllerWithTripleBuffer<NJointGripperZeroTorqueControllerControlData>,
        public NJointGripperZeroTorqueControllerInterface
    {
    public:
        using ConfigPtrT = NJointGripperZeroTorqueControllerConfigPtr;
        NJointGripperZeroTorqueController(const RobotUnitPtr&, const NJointControllerConfigPtr& config, const VirtualRobot::RobotPtr&);

        // NJointControllerInterface interface
        std::string getClassName(const Ice::Current&) const override;

        // NJointController interface

        void rtRun(const IceUtil::Time& sensorValuesTimestamp, const IceUtil::Time& timeSinceLastIteration) override;
        static WidgetDescription::WidgetPtr GenerateConfigDescription(
            const VirtualRobot::RobotPtr&,
            const std::map<std::string, ConstControlDevicePtr>&,
            const std::map<std::string, ConstSensorDevicePtr>&);

        static NJointGripperZeroTorqueControllerConfigPtr GenerateConfigFromVariants(const StringVariantBaseMap& values);

    private:
        std::vector<ControlTarget1DoFActuatorZeroTorque*> targets;
        //        std::vector<ControlTarget1DoFActuatorVelocity*> pumpTarget;
    };

} // namespace armarx

