#pragma once

#include <VirtualRobot/Util/json/json.hpp>
#include <QAbstractItemModel>

namespace armarx
{

    class JSONTreeModel : public QAbstractItemModel
    {
    public:
        using ValuePtr = nlohmann::json*;

        void setRoot(ValuePtr root);

        // QAbstractItemModel interface
        QModelIndex index(int row, int column, const QModelIndex& parent) const override;
        QModelIndex parent(const QModelIndex& index) const override;
        int rowCount(const QModelIndex& parent) const override;
        int columnCount(const QModelIndex& parent) const override;
        QVariant data(const QModelIndex& index, int role) const override;
        QVariant headerData(int section, Qt::Orientation orientation, int role) const override;

    private:
        ValuePtr refFrom(QModelIndex const& index) const;

    private:
        mutable std::map<ValuePtr, int> rows;
        mutable std::map<ValuePtr, ValuePtr> parents;
        mutable std::map<ValuePtr, std::string> names;
        ValuePtr root;
    };

}
